<html>
<head>
<title>Ogre::GLSLESProgramPipelineManager Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html">GLSLESProgramPipelineManager</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#pro-static-attribs">Static Protected Attributes</a> &#124;
<a href="#pri-types">Private Types</a> &#124;
<a href="#pri-attribs">Private Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::GLSLESProgramPipelineManager Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::GLSLESProgramPipelineManager" --><!-- doxytag: inherits="Ogre::GLSLESProgramManagerCommon,Singleton&lt; GLSLESProgramPipelineManager &gt;" -->
<p><a class="el" href="namespaceOgre.html">Ogre</a> assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one program pipeline object that represents the active vertex and fragment program objects during a rendering state.  
 <a href="classOgre_1_1GLSLESProgramPipelineManager.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreGLSLESProgramPipelineManager_8h_source.html">OgreGLSLESProgramPipelineManager.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::GLSLESProgramPipelineManager:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1GLSLESProgramPipelineManager__inherit__graph.gif" border="0" usemap="#Ogre_1_1GLSLESProgramPipelineManager_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1GLSLESProgramPipelineManager_inherit__map" id="Ogre_1_1GLSLESProgramPipelineManager_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1GLSLESProgramManagerCommon.html" title="Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one pr..." alt="" coords="5,5,267,35"/><area shape="rect" id="node4" href="classOgre_1_1Singleton.html" title="Ogre::Singleton\&lt; GLSLESProgramPipelineManager \&gt;" alt="" coords="291,5,621,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1GLSLESProgramPipelineManager-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#a9f08fbefe3e2e5d7ed62503a9bf0476b">GLSLESProgramPipelineManager</a> (void)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#a79a2813facdf6fdb6e03355b984da8b2">~GLSLESProgramPipelineManager</a> (void)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html">GLSLESProgramPipeline</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#abce662d414ffe746f8a9487f1b4a2a96">getActiveProgramPipeline</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the program object that links the two active program objects together.  <a href="#abce662d414ffe746f8a9487f1b4a2a96"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#af8eed1b7ffe696b33e4f8a857bdb1a26">setActiveVertexLinkProgram</a> (<a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *vertexGpuProgram)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the active vertex and fragment link programs for the next rendering state.  <a href="#af8eed1b7ffe696b33e4f8a857bdb1a26"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#ae19fd109e0db056111075ca42367a9be">setActiveFragmentLinkProgram</a> (<a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *fragmentGpuProgram)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#a8bf100ce684eddb08d22ffd4051370df">optimiseShaderSource</a> (<a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *gpuProgram)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#a6a67a50e5cda21f7965096b10780bc8e">extractUniforms</a> (GLuint programObject, const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *vertexConstantDefs, const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *fragmentConstantDefs, <a class="el" href="namespaceOgre.html#a24aca8d208dcf62fbe3bee9e759ac73d">GLUniformReferenceList</a> &amp;<a class="el" href="structOgre_1_1list.html">list</a>)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Populate a list of uniforms based on a program object.  <a href="#a6a67a50e5cda21f7965096b10780bc8e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#ab2c2b27a95604608ac39d32795d55301">extractConstantDefs</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;src, <a class="el" href="structOgre_1_1GpuNamedConstants.html">GpuNamedConstants</a> &amp;constantDefs, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;filename)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Populate a list of uniforms based on GLSL ES source.  <a href="#ab2c2b27a95604608ac39d32795d55301"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <br class="typebreak"/>
<a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html">GLSLESProgramPipelineManager</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#ac4a7c0a1aded6f3a5e6406db1e56e531">getSingleton</a> (void)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <br class="typebreak"/>
<a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html">GLSLESProgramPipelineManager</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#a87f9ce6de711d05b6e4ba704cb630863">getSingletonPtr</a> (void)</td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, GLenum &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#a7384fc46c60ddbd4e0070942dfaf6850">StringToEnumMap</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#aa8fb539b7b3019177e4767a6e1c9da47">completeDefInfo</a> (GLenum gltype, <a class="el" href="structOgre_1_1GpuConstantDefinition.html">GpuConstantDefinition</a> &amp;defToUpdate)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Use type to complete other information.  <a href="#aa8fb539b7b3019177e4767a6e1c9da47"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#a62b5aa3fdef96353b09cf441f847497e">completeParamSource</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;paramName, const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *vertexConstantDefs, const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *fragmentConstantDefs, <a class="el" href="structOgre_1_1GLUniformReference.html">GLUniformReference</a> &amp;refToUpdate)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Find where the data for a specific uniform should come from, populate.  <a href="#a62b5aa3fdef96353b09cf441f847497e"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#ad6a666ba0e4312cec7113fe617d951e3">mActiveVertexGpuProgram</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Active objects defining the active rendering gpu state.  <a href="#ad6a666ba0e4312cec7113fe617d951e3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#a11183e2ef747ebb357d7d3d28b5d95df">mActiveFragmentGpuProgram</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#a7384fc46c60ddbd4e0070942dfaf6850">StringToEnumMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#afeddc48851b31cceed65f7d0ad879180">mTypeEnumMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct glslopt_ctx *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#a014c27ca722e63bd51ab750558103b38">mGLSLOptimiserContext</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-static-attribs"></a>
Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <br class="typebreak"/>
<a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html">GLSLESProgramPipelineManager</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a></td></tr>
<tr><td colspan="2"><h2><a name="pri-types"></a>
Private Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; <a class="el" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>, <br class="typebreak"/>
<a class="el" href="classOgre_1_1GLSLESProgramPipeline.html">GLSLESProgramPipeline</a> * &gt;<br class="typebreak"/>
::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#ad5cf10b8305705de668613cc7f49367b">ProgramPipelineMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <br class="typebreak"/>
ProgramPipelineMap::iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#ad6099086f5ae360ca61421639fdde223">ProgramPipelineIterator</a></td></tr>
<tr><td colspan="2"><h2><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#ad5cf10b8305705de668613cc7f49367b">ProgramPipelineMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#a9ea494750c752c2d59224ec818ceea40">mProgramPipelines</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Container holding previously created program pipeline objects.  <a href="#a9ea494750c752c2d59224ec818ceea40"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html">GLSLESProgramPipeline</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#aaafd98ec01e062a1914bf706f18d4c62">mActiveProgramPipeline</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Active objects defining the active rendering gpu state.  <a href="#aaafd98ec01e062a1914bf706f18d4c62"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p><a class="el" href="namespaceOgre.html">Ogre</a> assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one program pipeline object that represents the active vertex and fragment program objects during a rendering state. </p>
<p>GLSL vertex and fragment program objects are compiled separately and then attached to a program object and then the program pipeline object is linked. Since <a class="el" href="namespaceOgre.html">Ogre</a> can only handle one vertex program stage and one fragment program stage being active in a pass, the GLSL ES Program Pipeline Manager does the same. The GLSL ES Program Pipeline Manager acts as a state machine and activates a pipeline object based on the active vertex and fragment program. Previously created pipeline objects are stored along with a unique key in a hash_map for quick retrieval the next time the pipeline object is required. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramPipelineManager_8h_source.html#l00048">48</a> of file <a class="el" href="OgreGLSLESProgramPipelineManager_8h_source.html">OgreGLSLESProgramPipelineManager.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="ad6099086f5ae360ca61421639fdde223"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::ProgramPipelineIterator" ref="ad6099086f5ae360ca61421639fdde223" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef ProgramPipelineMap::iterator <a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#ad6099086f5ae360ca61421639fdde223">Ogre::GLSLESProgramPipelineManager::ProgramPipelineIterator</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLESProgramPipelineManager_8h_source.html#l00053">53</a> of file <a class="el" href="OgreGLSLESProgramPipelineManager_8h_source.html">OgreGLSLESProgramPipelineManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="ad5cf10b8305705de668613cc7f49367b"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::ProgramPipelineMap" ref="ad5cf10b8305705de668613cc7f49367b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;<a class="el" href="namespaceOgre.html#a7e1487b57f16a1479302d1896c6f4445">uint64</a>, <a class="el" href="classOgre_1_1GLSLESProgramPipeline.html">GLSLESProgramPipeline</a>*&gt;::type <a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#ad5cf10b8305705de668613cc7f49367b">Ogre::GLSLESProgramPipelineManager::ProgramPipelineMap</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLESProgramPipelineManager_8h_source.html#l00052">52</a> of file <a class="el" href="OgreGLSLESProgramPipelineManager_8h_source.html">OgreGLSLESProgramPipelineManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a7384fc46c60ddbd4e0070942dfaf6850"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::StringToEnumMap" ref="a7384fc46c60ddbd4e0070942dfaf6850" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, GLenum&gt;::type <a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#a7384fc46c60ddbd4e0070942dfaf6850">Ogre::GLSLESProgramManagerCommon::StringToEnumMap</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented in <a class="el" href="classOgre_1_1GLSLESLinkProgramManager.html#abf805003d882f3d41d601862cc70d66d">Ogre::GLSLESLinkProgramManager</a>.</p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramManagerCommon_8h_source.html#l00061">61</a> of file <a class="el" href="OgreGLSLESProgramManagerCommon_8h_source.html">OgreGLSLESProgramManagerCommon.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a9f08fbefe3e2e5d7ed62503a9bf0476b"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::GLSLESProgramPipelineManager" ref="a9f08fbefe3e2e5d7ed62503a9bf0476b" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#a9f08fbefe3e2e5d7ed62503a9bf0476b">Ogre::GLSLESProgramPipelineManager::GLSLESProgramPipelineManager</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a79a2813facdf6fdb6e03355b984da8b2"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::~GLSLESProgramPipelineManager" ref="a79a2813facdf6fdb6e03355b984da8b2" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#a79a2813facdf6fdb6e03355b984da8b2">Ogre::GLSLESProgramPipelineManager::~GLSLESProgramPipelineManager</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="aa8fb539b7b3019177e4767a6e1c9da47"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::completeDefInfo" ref="aa8fb539b7b3019177e4767a6e1c9da47" args="(GLenum gltype, GpuConstantDefinition &amp;defToUpdate)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#aa8fb539b7b3019177e4767a6e1c9da47">Ogre::GLSLESProgramManagerCommon::completeDefInfo</a> </td>
          <td>(</td>
          <td class="paramtype">GLenum&#160;</td>
          <td class="paramname"><em>gltype</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structOgre_1_1GpuConstantDefinition.html">GpuConstantDefinition</a> &amp;&#160;</td>
          <td class="paramname"><em>defToUpdate</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Use type to complete other information. </p>

</div>
</div>
<a class="anchor" id="a62b5aa3fdef96353b09cf441f847497e"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::completeParamSource" ref="a62b5aa3fdef96353b09cf441f847497e" args="(const String &amp;paramName, const GpuConstantDefinitionMap *vertexConstantDefs, const GpuConstantDefinitionMap *fragmentConstantDefs, GLUniformReference &amp;refToUpdate)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#a62b5aa3fdef96353b09cf441f847497e">Ogre::GLSLESProgramManagerCommon::completeParamSource</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>paramName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *&#160;</td>
          <td class="paramname"><em>vertexConstantDefs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *&#160;</td>
          <td class="paramname"><em>fragmentConstantDefs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structOgre_1_1GLUniformReference.html">GLUniformReference</a> &amp;&#160;</td>
          <td class="paramname"><em>refToUpdate</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Find where the data for a specific uniform should come from, populate. </p>

</div>
</div>
<a class="anchor" id="ab2c2b27a95604608ac39d32795d55301"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::extractConstantDefs" ref="ab2c2b27a95604608ac39d32795d55301" args="(const String &amp;src, GpuNamedConstants &amp;constantDefs, const String &amp;filename)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#ab2c2b27a95604608ac39d32795d55301">Ogre::GLSLESProgramManagerCommon::extractConstantDefs</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structOgre_1_1GpuNamedConstants.html">GpuNamedConstants</a> &amp;&#160;</td>
          <td class="paramname"><em>constantDefs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>filename</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Populate a list of uniforms based on GLSL ES source. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">src</td><td>Reference to the source code </td></tr>
    <tr><td class="paramname">list</td><td>The defs to populate (will not be cleared before adding, clear it yourself before calling this if that's what you want). </td></tr>
    <tr><td class="paramname">filename</td><td>The file name this came from, for logging errors. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a6a67a50e5cda21f7965096b10780bc8e"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::extractUniforms" ref="a6a67a50e5cda21f7965096b10780bc8e" args="(GLuint programObject, const GpuConstantDefinitionMap *vertexConstantDefs, const GpuConstantDefinitionMap *fragmentConstantDefs, GLUniformReferenceList &amp;list)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#a6a67a50e5cda21f7965096b10780bc8e">Ogre::GLSLESProgramManagerCommon::extractUniforms</a> </td>
          <td>(</td>
          <td class="paramtype">GLuint&#160;</td>
          <td class="paramname"><em>programObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *&#160;</td>
          <td class="paramname"><em>vertexConstantDefs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a> *&#160;</td>
          <td class="paramname"><em>fragmentConstantDefs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a24aca8d208dcf62fbe3bee9e759ac73d">GLUniformReferenceList</a> &amp;&#160;</td>
          <td class="paramname"><em>list</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Populate a list of uniforms based on a program object. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">programObject</td><td>Handle to the program object to query </td></tr>
    <tr><td class="paramname">vertexConstantDefs</td><td>Definition of the constants extracted from the vertex program, used to match up physical buffer indexes with program uniforms. May be null if there is no vertex program. </td></tr>
    <tr><td class="paramname">fragmentConstantDefs</td><td>Definition of the constants extracted from the fragment program, used to match up physical buffer indexes with program uniforms. May be null if there is no fragment program. </td></tr>
    <tr><td class="paramname">list</td><td>The list to populate (will not be cleared before adding, clear it yourself before calling this if that's what you want). </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="abce662d414ffe746f8a9487f1b4a2a96"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::getActiveProgramPipeline" ref="abce662d414ffe746f8a9487f1b4a2a96" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html">GLSLESProgramPipeline</a>* <a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#abce662d414ffe746f8a9487f1b4a2a96">Ogre::GLSLESProgramPipelineManager::getActiveProgramPipeline</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the program object that links the two active program objects together. </p>
<p>If a program pipeline object was not already created and linked a new one is created and linked. </p>

</div>
</div>
<a class="anchor" id="ac4a7c0a1aded6f3a5e6406db1e56e531"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::getSingleton" ref="ac4a7c0a1aded6f3a5e6406db1e56e531" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html">GLSLESProgramPipelineManager</a>&amp; <a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#ac4a7c0a1aded6f3a5e6406db1e56e531">Ogre::GLSLESProgramPipelineManager::getSingleton</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented from <a class="el" href="classOgre_1_1Singleton.html#a7757bd7ac3702c144502e53ad6491888">Ogre::Singleton&lt; GLSLESProgramPipelineManager &gt;</a>.</p>

</div>
</div>
<a class="anchor" id="a87f9ce6de711d05b6e4ba704cb630863"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::getSingletonPtr" ref="a87f9ce6de711d05b6e4ba704cb630863" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html">GLSLESProgramPipelineManager</a>* <a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#a87f9ce6de711d05b6e4ba704cb630863">Ogre::GLSLESProgramPipelineManager::getSingletonPtr</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented from <a class="el" href="classOgre_1_1Singleton.html#a7ab51c46521b89723d6186a52a7e0d7b">Ogre::Singleton&lt; GLSLESProgramPipelineManager &gt;</a>.</p>

</div>
</div>
<a class="anchor" id="a8bf100ce684eddb08d22ffd4051370df"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::optimiseShaderSource" ref="a8bf100ce684eddb08d22ffd4051370df" args="(GLSLESGpuProgram *gpuProgram)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#a8bf100ce684eddb08d22ffd4051370df">Ogre::GLSLESProgramManagerCommon::optimiseShaderSource</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *&#160;</td>
          <td class="paramname"><em>gpuProgram</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ae19fd109e0db056111075ca42367a9be"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::setActiveFragmentLinkProgram" ref="ae19fd109e0db056111075ca42367a9be" args="(GLSLESGpuProgram *fragmentGpuProgram)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#ae19fd109e0db056111075ca42367a9be">Ogre::GLSLESProgramPipelineManager::setActiveFragmentLinkProgram</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *&#160;</td>
          <td class="paramname"><em>fragmentGpuProgram</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="af8eed1b7ffe696b33e4f8a857bdb1a26"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::setActiveVertexLinkProgram" ref="af8eed1b7ffe696b33e4f8a857bdb1a26" args="(GLSLESGpuProgram *vertexGpuProgram)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#af8eed1b7ffe696b33e4f8a857bdb1a26">Ogre::GLSLESProgramPipelineManager::setActiveVertexLinkProgram</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a> *&#160;</td>
          <td class="paramname"><em>vertexGpuProgram</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the active vertex and fragment link programs for the next rendering state. </p>
<p>The active program pipeline object will be cleared. Normally called from the <a class="el" href="classOgre_1_1GLSLESGpuProgram.html#a1f27bdccdf5d428b6e796d6fb705e559" title="Execute the binding functions for this program.">GLSLESGpuProgram::bindProgram</a> and unbindProgram methods </p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a11183e2ef747ebb357d7d3d28b5d95df"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::mActiveFragmentGpuProgram" ref="a11183e2ef747ebb357d7d3d28b5d95df" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a>* <a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#a11183e2ef747ebb357d7d3d28b5d95df">Ogre::GLSLESProgramManagerCommon::mActiveFragmentGpuProgram</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLESProgramManagerCommon_8h_source.html#l00059">59</a> of file <a class="el" href="OgreGLSLESProgramManagerCommon_8h_source.html">OgreGLSLESProgramManagerCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="aaafd98ec01e062a1914bf706f18d4c62"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::mActiveProgramPipeline" ref="aaafd98ec01e062a1914bf706f18d4c62" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESProgramPipeline.html">GLSLESProgramPipeline</a>* <a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#aaafd98ec01e062a1914bf706f18d4c62">Ogre::GLSLESProgramPipelineManager::mActiveProgramPipeline</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Active objects defining the active rendering gpu state. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramPipelineManager_8h_source.html#l00059">59</a> of file <a class="el" href="OgreGLSLESProgramPipelineManager_8h_source.html">OgreGLSLESProgramPipelineManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="ad6a666ba0e4312cec7113fe617d951e3"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::mActiveVertexGpuProgram" ref="ad6a666ba0e4312cec7113fe617d951e3" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESGpuProgram.html">GLSLESGpuProgram</a>* <a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#ad6a666ba0e4312cec7113fe617d951e3">Ogre::GLSLESProgramManagerCommon::mActiveVertexGpuProgram</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Active objects defining the active rendering gpu state. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramManagerCommon_8h_source.html#l00058">58</a> of file <a class="el" href="OgreGLSLESProgramManagerCommon_8h_source.html">OgreGLSLESProgramManagerCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="a014c27ca722e63bd51ab750558103b38"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::mGLSLOptimiserContext" ref="a014c27ca722e63bd51ab750558103b38" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">struct glslopt_ctx* <a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#a014c27ca722e63bd51ab750558103b38">Ogre::GLSLESProgramManagerCommon::mGLSLOptimiserContext</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreGLSLESProgramManagerCommon_8h_source.html#l00064">64</a> of file <a class="el" href="OgreGLSLESProgramManagerCommon_8h_source.html">OgreGLSLESProgramManagerCommon.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9ea494750c752c2d59224ec818ceea40"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::mProgramPipelines" ref="a9ea494750c752c2d59224ec818ceea40" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#ad5cf10b8305705de668613cc7f49367b">ProgramPipelineMap</a> <a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html#a9ea494750c752c2d59224ec818ceea40">Ogre::GLSLESProgramPipelineManager::mProgramPipelines</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Container holding previously created program pipeline objects. </p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramPipelineManager_8h_source.html#l00056">56</a> of file <a class="el" href="OgreGLSLESProgramPipelineManager_8h_source.html">OgreGLSLESProgramPipelineManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="aff0baaaed91d8505cfb72b7725ae1c37"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::msSingleton" ref="aff0baaaed91d8505cfb72b7725ae1c37" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html">GLSLESProgramPipelineManager</a> * <a class="el" href="classOgre_1_1Singleton.html">Ogre::Singleton</a>&lt; <a class="el" href="classOgre_1_1GLSLESProgramPipelineManager.html">GLSLESProgramPipelineManager</a>  &gt;::<a class="el" href="classOgre_1_1Singleton.html#aff0baaaed91d8505cfb72b7725ae1c37">msSingleton</a><code> [static, protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreSingleton_8h_source.html#l00075">75</a> of file <a class="el" href="OgreSingleton_8h_source.html">OgreSingleton.h</a>.</p>

</div>
</div>
<a class="anchor" id="afeddc48851b31cceed65f7d0ad879180"></a><!-- doxytag: member="Ogre::GLSLESProgramPipelineManager::mTypeEnumMap" ref="afeddc48851b31cceed65f7d0ad879180" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#a7384fc46c60ddbd4e0070942dfaf6850">StringToEnumMap</a> <a class="el" href="classOgre_1_1GLSLESProgramManagerCommon.html#afeddc48851b31cceed65f7d0ad879180">Ogre::GLSLESProgramManagerCommon::mTypeEnumMap</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented in <a class="el" href="classOgre_1_1GLSLESLinkProgramManager.html#a630e270fbdf85b6d09fb21c06c427805">Ogre::GLSLESLinkProgramManager</a>.</p>

<p>Definition at line <a class="el" href="OgreGLSLESProgramManagerCommon_8h_source.html#l00062">62</a> of file <a class="el" href="OgreGLSLESProgramManagerCommon_8h_source.html">OgreGLSLESProgramManagerCommon.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreGLSLESProgramPipelineManager_8h_source.html">OgreGLSLESProgramPipelineManager.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:31
</p>
</body>
</html>
